/* Copyright 1995 Yggdrasil Computing, Inc.
   Written by Adam J. Richter (adam@yggdrasil.com).
   This file may be copied under the terms and conditions of the
   GNU General Public License as published by the Free Software
   Foundation (Cambridge, Massachusetts, USA).
*/

typedef enum {BIG_END, LITTLE_END} byte_order_t;
typedef enum {DATE, NUMERIC, STRING} data_type_t;
typedef enum {EQUAL, NOT_EQUAL, GREATER, LESS,
	      BITS_SET, BITS_CLEAR, ALWAYS_TRUE} compare_t;

struct match {
    int level;
    int indirect;

    int index_location;	/* These three fields used only if indirect=1 */
    int index_size;	/* 1 = byte, 2 = short, 4 = long */
    byte_order_t index_byte_order;

    long offset;
    data_type_t data_type;
    byte_order_t byte_order;
    compare_t comparison;
    unsigned int numbytes;
    char *compare_string;
    unsigned long compare_num;
    unsigned long compare_mask;
    char *format_string;

    struct match *parent, *child, *sibling;
};

extern byte_order_t native_byte_order;

